//  File:  ExtendInnerClass.java
//
//  Demonstrate how to extend an inner class

public class ExtendInnerClass {

	public static void main(String[] args) {
		System.out.println("Show how to extend an inner class");
		System.out.println();

		System.out.println("Instantiating Outer...");
		new Outer();
		System.out.println();

		System.out.println("Instantiating ExtendOuter...");
		new ExtendOuter();
		System.out.println();
	}

}

class Outer {

	Outer() {
		System.out.println("Outer");
		new Inner();
		System.out.println();
		new DerivedInner();
	}

	class Inner {
		Inner() { System.out.println("Inner"); }
	}

	class DerivedInner extends Inner {
		DerivedInner() { System.out.println("DerivedInner"); }
	}

}

class ExtendOuter extends Outer {

	ExtendOuter() {
		System.out.println("ExtendOuter");
		new ExtendInner();
		System.out.println();
		new ExtendDerivedInner();
	}

	class ExtendInner extends Inner {
		ExtendInner() { System.out.println("ExtendInner"); }
	}

	class ExtendDerivedInner extends DerivedInner {
		ExtendDerivedInner() { System.out.println("ExtendDerivedInner"); }
	}

}

/* ..... Output from the program .....

Show how to extend an inner class

Instantiating Outer...
Outer
Inner

Inner
DerivedInner

Instantiating ExtendOuter...
Outer
Inner

Inner
DerivedInner
ExtendOuter
Inner
ExtendInner

Inner
DerivedInner
ExtendDerivedInner

..... End of Output ..... */
